package file

import (
	"io/ioutil"
	"log"
	"path/filepath"
	"regexp"

	"github.com/fsnotify/fsnotify"

	"trustmail/mail"
	"trustmail/model"
)

func FileWatcher(path string) {
	// FileWatcher: for watch file

	go checkStartFiles(path)

	watcher, err := fsnotify.NewWatcher()
	if err != nil {
		log.Fatal(err)
	}
	defer watcher.Close()

	done := make(chan bool)
	go func() {
		for {
			select {
			case event := <-watcher.Events:
				log.Println("event:", event)
				if event.Op&fsnotify.Write == fsnotify.Write {
					log.Println("modified file:", event.Name)

					excute(event.Name)
				}
			case err := <-watcher.Errors:
				log.Println("error:", err)
			}
		}
	}()

	err = watcher.Add(path)
	if err != nil {
		log.Fatal(err)
	}
	<-done
}

func checkStartFiles(path string) {
	files, _ := ioutil.ReadDir(path)
	for _, f := range files {
		excute(path + "/" + f.Name())
	}
}

func excute(fileName string) {

	r, _ := regexp.Compile(`.DS_Store`)
	if r.MatchString(fileName) == false {

		m := mail.MailParser(fileName)

		model.InsertMail(m)

		err := MoveFileToCur(fileName, "./resources/cur/"+filepath.Base(fileName))
		if err != nil {
			MoveFileToCur(fileName, "./resources/block/"+filepath.Base(fileName))
			log.Println("Error move file : ", err)
		}

	}
}
